.\"	$NetBSD: ubsec.4,v 1.3 2004/04/29 08:44:17 wiz Exp $
.\"	$FreeBSD: src/share/man/man4/ubsec.4,v 1.1.2.1 2002/11/21 23:57:24 sam Exp $
.\"	$OpenBSD: ubsec.4,v 1.26 2003/09/03 15:55:41 jason Exp $
.\"
.\" Copyright (c) 2000 Jason L. Wright (jason@thought.net)
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
.\" STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
.\" ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd June 10, 2000
.Dt UBSEC 4
.Os
.Sh NAME
.Nm ubsec
.Nd Broadcom and BlueSteel uBsec 5x0x crypto accelerator
.Sh SYNOPSIS
.Cd "ubsec* at pci? dev ? function ?"
.Sh DESCRIPTION
The
.Nm
driver supports cards containing any of the following chips:
.Bl -tag -width "Broadcom BCM5821" -offset indent
.It Bluesteel 5501
The original chipset, no longer made.
This extremely rare unit
was not very fast, lacked an RNG, and had a number of other bugs.
.It Bluesteel 5601
A faster and fixed version of the original, with a random number
unit and large number engine added.
.It Broadcom BCM5801
A BCM5805 without public key engine or random number generator.
.It Broadcom BCM5802
A slower version of the BCM5805.
.It Broadcom BCM5805
Faster version of Bluesteel 5601.
.It Broadcom BCM5820
64 bit version of the chip, and significantly more advanced.
.It Broadcom BCM5821
Faster version of the BCM5820.
(This is the chip found on the Sun Crypto Accelerator 1000.)
.It Broadcom BCM5822
Faster version of the BCM5820.
.It Broadcom BCM5823
Faster version of the BCM5822.
.It Broadcom BCM5823
Faster version of the BCM5821, with AES hardware.
.El
.Pp
The
.Nm
driver registers itself to accelerate DES, Triple-DES, MD5, SHA1,
MD5-HMAC, and SHA1-HMAC operations for
.Xr opencrypto 9 ,
and thus for
.Xr fast_ipsec 4
and
.Xr crypto 4 .
.Pp
On those models which contain a public key engine (almost all of the
more recent ones), this feature is registered with the
.Xr crypto 4
subsystem.
.Pp
On all models except the Bluesteel 5501 and Broadcom 5801, the driver
registers itself to provide random data to the
.Xr rnd 4
subsystem.
.Sh SEE ALSO
.Xr crypto 4 ,
.Xr fast_ipsec 4 ,
.Xr intro 4 ,
.Xr rnd 4 ,
.Xr opencrypto 9
.Sh HISTORY
The
.Nm
device driver appeared in
.Ox 2.8 .
The
.Nm
device driver was imported to
.Fx 5.0 ,
back-ported to
.Fx 4.8 ,
and subsequently imported to
.Nx 2.0 .
.Sh BUGS
The BCM5801 and BCM5802 have not actually been tested.
.Pp
Whilst some of the newer chips support AES, AES is not supported by the driver.
